=== modified file 'drizzled/Makefile.am'
--- drizzled/Makefile.am	2008-10-25 06:24:15 +0000
+++ drizzled/Makefile.am	2008-10-28 00:11:42 +0000
@@ -121,6 +121,7 @@
 		probes.h \
 		protocol.h \
 		qcache.h \
+		query_id.h \
 		rpl_constants.h \
 		rpl_filter.h \
 		rpl_mi.h \
@@ -199,6 +200,7 @@
 		parser.cc \
 		protocol.cc \
 		qcache.cc \
+		query_id.cc \
 		records.cc \
 		rpl_filter.cc \
 		rpl_mi.cc \

=== modified file 'drizzled/common_includes.h'
--- drizzled/common_includes.h	2008-10-23 06:29:32 +0000
+++ drizzled/common_includes.h	2008-10-27 23:19:48 +0000
@@ -72,8 +72,6 @@
 #include <drizzled/structs.h>
 /* Custom continguous-section memory allocator */
 #include <drizzled/sql_alloc.h>
-/* Definition of the MY_LOCALE struct and some convenience functions */
-#include <drizzled/sql_locale.h>
 
 #include <drizzled/korr.h>
 
@@ -84,33 +82,6 @@
 #endif
 #include "probes.h"
 
-/**
-  Query type constants.
-
-  QT_ORDINARY -- ordinary SQL query.
-  QT_IS -- SQL query to be shown in INFORMATION_SCHEMA (in utf8 and without
-  character set introducers).
-
-  @TODO
-
-  Move this out of here once Stew's done with UDF breakout.  The following headers need it:
-
-    sql_lex.h --> included by sql_class.h
-    item.h
-    table.h
-    item_func.h
-    item_subselect.h
-    item_timefunc.h
-    item_sum.h
-    item_cmpfunc.h
-    item_strfunc.h
-*/
-enum enum_query_type
-{
-  QT_ORDINARY,
-  QT_IS
-};
-
 
 /**
  * @TODO Move the following into a drizzled.h header?
@@ -119,92 +90,11 @@
  * and that are used only in the server should be separated out into 
  * a drizzled.h header file -- JRP
  */
-extern query_id_t global_query_id;
 
-/* increment query_id and return it.  */
-inline query_id_t next_query_id() { return global_query_id++; }
 
 extern const CHARSET_INFO *system_charset_info, *files_charset_info ;
 extern const CHARSET_INFO *national_charset_info, *table_alias_charset;
 
-/**
- * @TODO Move to a separate header?
- *
- * It's needed by item.h and field.h, which are both inter-dependent
- * and contain forward declarations of many structs/classes in the
- * other header file.
- *
- * What is needed is a separate header file that is included
- * by *both* item.h and field.h to resolve inter-dependencies
- *
- * But, probably want to hold off on this until Stew finished the UDF cleanup
- */
-enum Derivation
-{
-  DERIVATION_IGNORABLE= 5,
-  DERIVATION_COERCIBLE= 4,
-  DERIVATION_SYSCONST= 3,
-  DERIVATION_IMPLICIT= 2,
-  DERIVATION_NONE= 1,
-  DERIVATION_EXPLICIT= 0
-};
-
-/**
- * Opening modes for open_temporary_table and open_table_from_share
- *
- * @TODO Put this into an appropriate header. It is only needed in:
- *
- *    table.cc
- *    sql_base.cc
- */
-enum open_table_mode
-{
-  OTM_OPEN= 0,
-  OTM_CREATE= 1,
-  OTM_ALTER= 2
-};
-
-enum enum_parsing_place
-{
-  NO_MATTER
-  , IN_HAVING
-  , SELECT_LIST
-  , IN_WHERE
-  , IN_ON
-};
-
-enum enum_mysql_completiontype {
-  ROLLBACK_RELEASE= -2
-  , ROLLBACK= 1
-  , ROLLBACK_AND_CHAIN= 7
-  , COMMIT_RELEASE= -1
-  , COMMIT= 0
-  , COMMIT_AND_CHAIN= 6
-};
-
-enum enum_check_fields
-{
-  CHECK_FIELD_IGNORE
-  , CHECK_FIELD_WARN
-  , CHECK_FIELD_ERROR_FOR_NULL
-};
-
-enum enum_var_type
-{
-  OPT_DEFAULT= 0
-  , OPT_SESSION
-  , OPT_GLOBAL
-};
-
-/* Forward declarations */
-
-class TableList;
-class String;
-class Table;
-class Session;
-class user_var_entry;
-class Security_context;
-
 extern pthread_key(Session*, THR_Session);
 inline Session *_current_session(void)
 {
@@ -259,7 +149,8 @@
  */
 #if defined DRIZZLE_SERVER || defined INNODB_COMPATIBILITY_HOOKS
 bool check_global_access(Session *session, ulong want_access);
-int get_quote_char_for_identifier(Session *session, const char *name, uint32_t length);
+int get_quote_char_for_identifier(Session *session, const char *name,
+                                  uint32_t length);
 extern struct system_variables global_system_variables;
 extern uint32_t mysql_data_home_len;
 extern char *mysql_data_home,server_version[SERVER_VERSION_LENGTH],

=== modified file 'drizzled/definitions.h'
--- drizzled/definitions.h	2008-10-23 06:29:32 +0000
+++ drizzled/definitions.h	2008-10-27 23:19:48 +0000
@@ -17,6 +17,7 @@
  *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  */
 
+#include CSTDINT_H
 
 /**
  * @file
@@ -377,7 +378,104 @@
 #define IS_EQUAL_YES 1
 #define IS_EQUAL_PACK_LENGTH 2
 
+
+/**
+  Query type constants.
+
+  QT_ORDINARY -- ordinary SQL query.
+  QT_IS -- SQL query to be shown in INFORMATION_SCHEMA (in utf8 and without
+  character set introducers).
+
+  @TODO
+
+  Move this out of here once Stew's done with UDF breakout.  The following headers need it:
+
+    sql_lex.h --> included by sql_class.h
+    item.h
+    table.h
+    item_func.h
+    item_subselect.h
+    item_timefunc.h
+    item_sum.h
+    item_cmpfunc.h
+    item_strfunc.h
+*/
+enum enum_query_type
+{
+  QT_ORDINARY,
+  QT_IS
+};
+
+
+/**
+ * @TODO Move to a separate header?
+ *
+ * It's needed by item.h and field.h, which are both inter-dependent
+ * and contain forward declarations of many structs/classes in the
+ * other header file.
+ *
+ * What is needed is a separate header file that is included
+ * by *both* item.h and field.h to resolve inter-dependencies
+ *
+ * But, probably want to hold off on this until Stew finished the UDF cleanup
+ */
+enum Derivation
+{
+  DERIVATION_IGNORABLE= 5,
+  DERIVATION_COERCIBLE= 4,
+  DERIVATION_SYSCONST= 3,
+  DERIVATION_IMPLICIT= 2,
+  DERIVATION_NONE= 1,
+  DERIVATION_EXPLICIT= 0
+};
+
+/**
+ * Opening modes for open_temporary_table and open_table_from_share
+ *
+ * @TODO Put this into an appropriate header. It is only needed in:
+ *
+ *    table.cc
+ *    sql_base.cc
+ */
+enum open_table_mode
+{
+  OTM_OPEN= 0,
+  OTM_CREATE= 1,
+  OTM_ALTER= 2
+};
+
+enum enum_parsing_place
+{
+  NO_MATTER
+  , IN_HAVING
+  , SELECT_LIST
+  , IN_WHERE
+  , IN_ON
+};
+
+enum enum_mysql_completiontype {
+  ROLLBACK_RELEASE= -2
+  , ROLLBACK= 1
+  , ROLLBACK_AND_CHAIN= 7
+  , COMMIT_RELEASE= -1
+  , COMMIT= 0
+  , COMMIT_AND_CHAIN= 6
+};
+
+enum enum_check_fields
+{
+  CHECK_FIELD_IGNORE
+  , CHECK_FIELD_WARN
+  , CHECK_FIELD_ERROR_FOR_NULL
+};
+
+enum enum_var_type
+{
+  OPT_DEFAULT= 0
+  , OPT_SESSION
+  , OPT_GLOBAL
+};
+
 typedef uint64_t query_id_t;
 
-
 #endif /* DRIZZLE_SERVER_DEFINITIONS_H */

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2008-10-25 04:31:54 +0000
+++ drizzled/drizzled.cc	2008-10-27 23:19:48 +0000
@@ -314,7 +314,6 @@
 ulong binlog_cache_size= 0;
 ulong max_binlog_cache_size= 0;
 uint32_t refresh_version;  /* Increments on each reload */
-query_id_t global_query_id;
 ulong aborted_threads;
 ulong aborted_connects;
 ulong specialflag= 0;
@@ -4252,7 +4251,7 @@
   protocol_version= PROTOCOL_VERSION;
   what_to_log= ~ (1L << (uint) COM_TIME);
   refresh_version= 1L;	/* Increments on each reload */
-  global_query_id= thread_id= 1L;
+  thread_id= 1;
   my_stpcpy(server_version, VERSION);
   myisam_recover_options_str= "OFF";
   myisam_stats_method_str= "nulls_unequal";

=== modified file 'drizzled/handler.h'
--- drizzled/handler.h	2008-10-23 00:05:28 +0000
+++ drizzled/handler.h	2008-10-27 23:19:48 +0000
@@ -438,6 +438,7 @@
 /* The handler for a table type.  Will be included in the Table structure */
 
 class Table;
+class TableList;
 typedef struct st_table_share TABLE_SHARE;
 struct st_foreign_key_info;
 typedef struct st_foreign_key_info FOREIGN_KEY_INFO;

=== modified file 'drizzled/item.h'
--- drizzled/item.h	2008-10-20 04:28:21 +0000
+++ drizzled/item.h	2008-10-27 23:19:48 +0000
@@ -1094,6 +1094,7 @@
 
 class Item_equal;
 class COND_EQUAL;
+class user_var_entry;
 
 class Item_field :public Item_ident
 {

=== modified file 'drizzled/item_strfunc.cc'
--- drizzled/item_strfunc.cc	2008-10-25 04:31:54 +0000
+++ drizzled/item_strfunc.cc	2008-10-27 23:19:48 +0000
@@ -29,6 +29,7 @@
 #include <drizzled/server_includes.h>
 #include <mysys/sha1.h>
 #include <zlib.h>
+#include <drizzled/query_id.h>
 
 #ifdef __cplusplus
 extern "C" {
@@ -2549,6 +2550,7 @@
     ulong tmp= sql_rnd();
     unsigned char mac[6];
     int i;
+    const Query_id& query_id= Query_id::get_query_id();
     if (my_gethwaddr(mac))
     {
       /* purecov: begin inspected */
@@ -2558,7 +2560,7 @@
         with a clock_seq value (initialized random below), we use a separate
         randominit() here
       */
-      randominit(&uuid_rand, tmp + (ulong) session, tmp + (ulong)global_query_id);
+      randominit(&uuid_rand, tmp + (ulong) session, tmp + query_id.value());
       for (i=0; i < (int)sizeof(mac); i++)
         mac[i]=(unsigned char)(my_rnd(&uuid_rand)*255);
       /* purecov: end */    

=== modified file 'drizzled/log_event.cc'
--- drizzled/log_event.cc	2008-10-23 03:41:40 +0000
+++ drizzled/log_event.cc	2008-10-27 23:19:48 +0000
@@ -32,6 +32,7 @@
 #include <drizzled/gettext.h>
 #include <libdrizzle/libdrizzle.h>
 #include <drizzled/error.h>
+#include <drizzled/query_id.h>
 
 #define log_cs	&my_charset_utf8_general_ci
 
@@ -1650,6 +1651,7 @@
 {
   LEX_STRING new_db;
   int expected_error,actual_error= 0;
+  Query_id &query_id= Query_id::get_query_id();
   /*
     Colleagues: please never free(session->catalog) in MySQL. This would
     lead to bugs as here session->catalog is a part of an alloced block,
@@ -1694,9 +1696,7 @@
     session->set_time((time_t)when);
     session->query_length= q_len_arg;
     session->query= (char*)query_arg;
-    pthread_mutex_lock(&LOCK_thread_count);
-    session->query_id = next_query_id();
-    pthread_mutex_unlock(&LOCK_thread_count);
+    session->query_id= query_id.next();
     session->variables.pseudo_thread_id= thread_id;		// for temp tables
 
     if (ignored_error_code((expected_error= error_code)) ||
@@ -2818,6 +2818,7 @@
                                    bool use_rli_only_for_errors)
 {
   LEX_STRING new_db;
+  Query_id &query_id= Query_id::get_query_id();
   new_db.length= db_len;
   new_db.str= (char *) rpl_filter->get_rewrite_db(db, &new_db.length);
   session->set_db(new_db.str, new_db.length);
@@ -2870,9 +2871,7 @@
   if (rpl_filter->db_ok(session->db))
   {
     session->set_time((time_t)when);
-    pthread_mutex_lock(&LOCK_thread_count);
-    session->query_id = next_query_id();
-    pthread_mutex_unlock(&LOCK_thread_count);
+    session->query_id = query_id.next();
     /*
       Initing session->row_count is not necessary in theory as this variable has no
       influence in the case of the slave SQL thread (it is used to generate a
@@ -5728,14 +5727,13 @@
 {
   RPL_TableList *table_list;
   char *db_mem, *tname_mem;
+  Query_id &query_id= Query_id::get_query_id();
   size_t dummy_len;
   void *memory;
   assert(rli->sql_session == session);
 
   /* Step the query id to mark what columns that are actually used. */
-  pthread_mutex_lock(&LOCK_thread_count);
-  session->query_id= next_query_id();
-  pthread_mutex_unlock(&LOCK_thread_count);
+  session->query_id= query_id.next();
 
   if (!(memory= my_multi_malloc(MYF(MY_WME),
                                 &table_list, (uint) sizeof(RPL_TableList),

=== added file 'drizzled/query_id.cc'
--- drizzled/query_id.cc	1970-01-01 00:00:00 +0000
+++ drizzled/query_id.cc	2008-10-27 23:19:48 +0000
@@ -0,0 +1,48 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <config.h>
+#include <definitions.h>
+#include <drizzled/query_id.h>
+#include <mysys/my_pthread.h>
+
+Query_id::Query_id() : the_query_id(1)
+{
+  /* pthread_mutex_init always returns 0 */
+  (void)pthread_mutex_init(&LOCK_query_id, MY_MUTEX_INIT_FAST);
+}
+
+Query_id::~Query_id()
+{
+  pthread_mutex_destroy(&LOCK_query_id);
+}
+
+query_id_t Query_id::value() const
+{
+  return the_query_id;
+}
+
+query_id_t Query_id::next()
+{
+  pthread_mutex_lock(&LOCK_query_id);
+  query_id_t ret= the_query_id++;
+  pthread_mutex_unlock(&LOCK_query_id);
+  return ret;
+}
+

=== added file 'drizzled/query_id.h'
--- drizzled/query_id.h	1970-01-01 00:00:00 +0000
+++ drizzled/query_id.h	2008-10-27 23:19:48 +0000
@@ -0,0 +1,49 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_GLOBAL_QUERY_ID_H
+#define DRIZZLED_GLOBAL_QUERY_ID_H
+
+#include <pthread.h>
+
+class Query_id
+{
+public:
+  static Query_id& get_query_id() {
+    static Query_id the_id;
+    return the_id;
+  }
+  ~Query_id();
+
+  /* return current query_id value */
+  query_id_t value() const;
+
+  /* increment query_id and return it.  */
+  query_id_t next();
+  query_id_t the_query_id;
+
+private:
+  pthread_mutex_t LOCK_query_id;
+
+  Query_id();
+  Query_id(Query_id const&);
+  Query_id& operator=(Query_id const&);
+};
+
+#endif

=== modified file 'drizzled/sql_class.cc'
--- drizzled/sql_class.cc	2008-10-23 02:48:56 +0000
+++ drizzled/sql_class.cc	2008-10-27 23:19:48 +0000
@@ -29,6 +29,7 @@
 #include <mysys/mysys_err.h>
 #include <drizzled/error.h>
 #include <drizzled/innodb_plugin_extras.h>
+#include <drizzled/query_id.h>
 
 /*
   The following is used to initialise Table_ident with a internal
@@ -556,9 +557,10 @@
   protocol= &protocol_text;			// Default protocol
   protocol_text.init(this);
 
+  const Query_id& query_id= Query_id::get_query_id();
   tablespace_op= false;
   tmp= sql_rnd();
-  randominit(&rand, tmp + (ulong) &rand, tmp + (ulong) ::global_query_id);
+  randominit(&rand, tmp + (ulong) &rand, tmp + query_id.value());
   substitute_null_with_insert_id = false;
   thr_lock_info_init(&lock_info); /* safety: will be reset after start */
   thr_lock_owner_init(&main_lock_id, &lock_info);

=== modified file 'drizzled/sql_class.h'
--- drizzled/sql_class.h	2008-10-24 03:07:51 +0000
+++ drizzled/sql_class.h	2008-10-27 23:19:48 +0000
@@ -24,6 +24,7 @@
 #include "log.h"
 #include "rpl_tblmap.h"
 #include <libdrizzle/password.h>     // rand_struct
+#include <drizzled/sql_locale.h>
 
 class Relay_log_info;
 

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2008-10-23 23:53:49 +0000
+++ drizzled/sql_parse.cc	2008-10-27 23:19:48 +0000
@@ -20,6 +20,7 @@
 #include "logging.h"
 #include <drizzled/error.h>
 #include <drizzled/nested_join.h>
+#include <drizzled/query_id.h>
 
 /**
   @defgroup Runtime_Environment Runtime Environment
@@ -490,16 +491,17 @@
         COM_QUIT/COM_SHUTDOWN
 */
 bool dispatch_command(enum enum_server_command command, Session *session,
-		      char* packet, uint32_t packet_length)
+                      char* packet, uint32_t packet_length)
 {
   NET *net= &session->net;
   bool error= 0;
+  Query_id &query_id= Query_id::get_query_id();
 
   session->command=command;
   session->lex->sql_command= SQLCOM_END; /* to avoid confusing VIEW detectors */
   session->set_time();
   pthread_mutex_lock(&LOCK_thread_count);
-  session->query_id= global_query_id;
+  session->query_id= query_id.value();
 
   switch( command ) {
   /* Ignore these statements. */
@@ -508,7 +510,7 @@
   /* Increase id and count all other statements. */
   default:
     statistic_increment(session->status_var.questions, &LOCK_status);
-    next_query_id();
+    query_id.next();
   }
 
   thread_running++;
@@ -677,7 +679,7 @@
         Count each statement from the client.
       */
       statistic_increment(session->status_var.questions, &LOCK_status);
-      session->query_id= next_query_id();
+      session->query_id= query_id.next();
       session->set_time(); /* Reset the query start time. */
       /* TODO: set session->lex->sql_command to SQLCOM_END here */
       pthread_mutex_unlock(&LOCK_thread_count);

